Imports System.ComponentModel

Public Class TipComboBox
    Inherits System.Windows.Forms.ComboBox

    Private Const AutomaticDelayDefault As Integer = 500

    Private WithEvents _dropDownList As ComboLBoxCustom
    Private _listToolTip As ListToolTip
    Private _tipMember As BindingMemberInfo
    Private _useAutomaticDelay As Boolean
    Private _lastSelectedIndex As Integer = -1

    Public Sub New()
        MyBase.New()
        _dropDownList = New ComboLBoxCustom(ListHandle)
        _listToolTip = New ListToolTip(ListHandle)
        AutomaticDelay = AutomaticDelayDefault
    End Sub

    <Category("Data"), _
    Bindable(True), _
    Editor("System.Windows.Forms.Design.DataMemberFieldEditor, System.Design", _
           "System.Drawing.Design.UITypeEditor, System.Drawing"), _
    Description("Rg[̃ACeɑ΂āAc[`bvƂĎgpvpeB܂B")> _
    Public Property TipMember() As String
        Get
            Return _tipMember.BindingMember
        End Get
        Set(ByVal Value As String)
            _tipMember = New BindingMemberInfo(Value)
        End Set
    End Property

    <Browsable(False)> _
    Public Property SelectedTip() As String
        Get
            If Me.DataManager Is Nothing OrElse Me.SelectedIndex = -1 Then
                Return String.Empty
            End If
            Dim item As Object = Me.DataManager.List.Item(Me.SelectedIndex)
            Return GetItemTip(item)
        End Get
        Set(ByVal Value As String)
            If Me.DataManager Is Nothing Then Return
            Dim col As PropertyDescriptorCollection = Me.DataManager.GetItemProperties()
            Dim prop As PropertyDescriptor = col.Find(TipMember, True)
            Dim i As Integer
            For i = 0 To Me.DataManager.Count - 1
                If prop.GetValue(Me.DataManager.List.Item(i)).ToString() = Value Then
                    Me.SelectedIndex = i
                    Return
                End If
            Next
        End Set
    End Property

    <DefaultValue(AutomaticDelayDefault), RefreshProperties(RefreshProperties.All), _
    Description("AutoPopDelayAInitialDelayA ReshowDelay ̒lK؂Ȓlɐݒ肵܂B")> _
    Public Property AutomaticDelay() As Integer
        Get
            Return _listToolTip.AutomaticDelay
        End Get
        Set(ByVal Value As Integer)
            _useAutomaticDelay = True
            _listToolTip.AutomaticDelay = Value
        End Set
    End Property

    <RefreshProperties(RefreshProperties.All), _
    Description("c[ qg̏ꏊŃ|C^Î~ꍇɁAc[ qg EBhE\Ă鎞Ԃ̒肵܂B")> _
    Public Property AutoPopDelay() As Integer
        Get
            Return _listToolTip.AutoPopDelay
        End Get
        Set(ByVal Value As Integer)
            _useAutomaticDelay = False
            _listToolTip.AutoPopDelay = Value
        End Set
    End Property

    <RefreshProperties(RefreshProperties.All), _
    Description("|C^c[ qgŐÎ~ƂɁAc[ qg EBhE\܂ł̎Ԃ̒肵܂B")> _
    Public Property InitialDelay() As Integer
        Get
            Return _listToolTip.InitialDelay
        End Get
        Set(ByVal Value As Integer)
            _useAutomaticDelay = False
            _listToolTip.InitialDelay = Value
        End Set
    End Property

    <RefreshProperties(RefreshProperties.All), _
    Description("c[ qgʂ̃c[ qgփ|C^𓮂ƂɁÃc[ qg\܂ł̎Ԃ肵܂B")> _
    Public Property ReshowDelay() As Integer
        Get
            Return _listToolTip.ReshowDelay
        End Get
        Set(ByVal Value As Integer)
            _useAutomaticDelay = False
            _listToolTip.ReshowDelay = Value
        End Set
    End Property

    Public Function GetItemTip(ByVal item As Object) As String
        If Not Me.DataManager Is Nothing AndAlso TipMember <> String.Empty Then
            Dim fil As Object = Me.FilterItemOnProperty(item, TipMember)
            If Not fil Is Nothing Then
                Return fil.ToString()
            End If
        End If
        Return String.Empty
    End Function

    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not _dropDownList Is Nothing Then
                _dropDownList.ReleaseHandle()
                _dropDownList = Nothing
            End If
            If Not _listToolTip Is Nothing Then
                _listToolTip.Dispose()
                _listToolTip = Nothing
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    Protected Overrides Sub WndProc(ByRef m As System.Windows.Forms.Message)
        If m.Msg = WM_CTLCOLORLISTBOX Then
            If _lastSelectedIndex <> SelectedIndex Then
                _lastSelectedIndex = SelectedIndex
                If _listToolTip.Activate Then
                    _listToolTip.Activate = False
                End If
                _listToolTip.Text = SelectedTip
                _listToolTip.Activate = True
            End If
        End If
        MyBase.WndProc(m)
    End Sub

    Private Function ShouldSerializeAutoPopDelay() As Boolean
        Return Not _useAutomaticDelay
    End Function

    Private Function ShouldSerializeInitialDelay() As Boolean
        Return Not _useAutomaticDelay
    End Function

    Private Function ShouldSerializeReshowDelay() As Boolean
        Return Not _useAutomaticDelay
    End Function

    Private ReadOnly Property ListHandle() As IntPtr
        Get
            Dim cbi As COMBOBOXINFO = New COMBOBOXINFO
            cbi.cbSize = Marshal.SizeOf(cbi)
            GetComboBoxInfo(Me.Handle, cbi)
            Return cbi.hwndList
        End Get
    End Property

    Private Sub _dropDownList_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles _dropDownList.MouseEnter
        _listToolTip.Activate = True
    End Sub

    Private Sub _dropDownList_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles _dropDownList.MouseLeave, MyBase.DropDown
        _listToolTip.Activate = False
    End Sub

    ' MouseMove CxgeXg
    'Private Sub _dropDownList_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles _dropDownList.MouseMove
    '    '_listToolTip.Activate = True
    '    '_listToolTip.Text = String.Format("{0}, {1}", e.X, e.Y)
    'End Sub
End Class